import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.media.*;

public class AudioPlayerEventos extends MIDlet implements CommandListener, PlayerListener {

	/* Os comandos da aplicao					*/
	private Command cmdSair, cmdComear, cmdParar;

	private String [][]ficheiros = {{"/bark.wav", "audio/x-wav"},
									{"/pattern.mid", "audio/midi"},
									{"/test-wav.wav", "audio/x-wav"}};
	List lista;

	Player player = null;

    public AudioPlayerEventos() {
     	cmdSair = new Command("Sair", Command.EXIT, 2);
     	cmdComear = new Command("Comear", Command.SCREEN, 1);
     	cmdParar = new Command("Parar", Command.SCREEN, 1);

		lista = new List("Ficheiros udio", List.IMPLICIT);
		lista.append(ficheiros[0][0], null);
		lista.append(ficheiros[1][0], null);
		lista.append(ficheiros[2][0], null);

		lista.addCommand(cmdParar);
		lista.addCommand(cmdSair);

		lista.setCommandListener(this);
    }

    public void startApp() {
      	Display.getDisplay(this).setCurrent(lista);
    }

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSair) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == List.SELECT_COMMAND) {

			System.out.println(lista.getString(lista.getSelectedIndex()));
			String ficheiro = ficheiros[lista.getSelectedIndex()][0];
			String mime = ficheiros[lista.getSelectedIndex()][1];
			try {
				/* fechar o player anterior	*/
				if (player != null) {
					player.close();
				}
				player = Manager.createPlayer(getClass().getResourceAsStream(ficheiro), mime);
				player.addPlayerListener(this);
				player.start();/**/
			} catch (IOException ioe) {
				System.err.println(ioe.getMessage());
			} catch (MediaException me) {
				System.err.println(me.getMessage());
			}
		} else if (c == cmdParar) {
			if (player != null) {
				try {
					player.stop();
				} catch (MediaException me) {
					System.err.println(me.getMessage());
				}
			}
		}
	}

	public void playerUpdate(Player player, String event, Object eventData) {
		System.out.println("Evento: " + event);

		if (event == PlayerListener.STARTED) {
			System.out.println("\tMedia Time: " + ((Long)eventData).toString());
		} else if (event == PlayerListener.END_OF_MEDIA) {
			System.out.println("\tMedia Time: " + ((Long)eventData).toString());
		} else if (event == PlayerListener.STOPPED) {
			System.out.println("\tMedia Time: " + ((Long)eventData).toString());
		} else if (event == PlayerListener.CLOSED) {
		}
	}

	public void destroyApp(boolean unconditional) {}

	public void pauseApp() {}
}